diff --git a/includes/functions.php b/includes/functions.php
index 2e4ec22..b030601 100644
--- a/includes/functions.php
+++ b/includes/functions.php
@@ -2038,14 +2038,14 @@ function generate_pagination($base_url, $num_items, $per_page, $start_item, $add
 		if ($end != $total_pages) $end -= 2;
 	}
 
-	$page_string = ($on_page == 1) ? '<strong>1</strong>' : '<a href="' . $base_url . '">1</a>';
+	$page_string = ($on_page == 1) ? '<strong>1</strong>' : '<a href="' . clean_viewtopic_url($base_url) . '">1</a>';
 	$page_string .= ($start > 2) ? '<span class="page-dots"> … </span>' : $seperator;
 
 	$start_cnt = ($start == 1 ? 2 : $start);
 	$end_cnt = ($end == $total_pages ? $end - 1 : $end);
 	for ($i = $start_cnt; $i <= $end_cnt; $i++)
 	{
-		$page_string .= ($i == $on_page) ? '<strong>' . $i . '</strong>' : '<a href="' . $base_url . "{$url_delim}start=" . (($i - 1) * $per_page) . '">' . $i . '</a>';
+		$page_string .= ($i == $on_page) ? '<strong>' . $i . '</strong>' : '<a href="' . clean_viewtopic_url($base_url . "{$url_delim}start=" . (($i - 1) * $per_page)) . '">' . $i . '</a>';
 		if ($i < $end_cnt)
 		{
 			$page_string .= $seperator;
@@ -2053,18 +2053,18 @@ function generate_pagination($base_url, $num_items, $per_page, $start_item, $add
 	}
 
 	$page_string .= ($end < $total_pages) ? '<span class="page-dots"> … </span>' : $seperator;
-	$page_string .= ($on_page == $total_pages) ? '<strong>' . $total_pages . '</strong>' : '<a href="' . $base_url . "{$url_delim}start=" . (($total_pages - 1) * $per_page) . '">' . $total_pages . '</a>';
+	$page_string .= ($on_page == $total_pages) ? '<strong>' . $total_pages . '</strong>' : '<a href="' . clean_viewtopic_url($base_url . "{$url_delim}start=" . (($total_pages - 1) * $per_page)) . '">' . $total_pages . '</a>';
 
 	if ($add_prevnext_text)
 	{
 		if ($on_page != 1)
 		{
-			$page_string = '<a href="' . $base_url . "{$url_delim}start=" . (($on_page - 2) * $per_page) . '">' . $user->lang['PREVIOUS'] . '</a>&nbsp;&nbsp;' . $page_string;
+			$page_string = '<a href="' . clean_viewtopic_url($base_url . "{$url_delim}start=" . (($on_page - 2) * $per_page)) . '">' . $user->lang['PREVIOUS'] . '</a>&nbsp;&nbsp;' . $page_string;
 		}
 
 		if ($on_page != $total_pages)
 		{
-			$page_string .= '&nbsp;&nbsp;<a href="' . $base_url . "{$url_delim}start=" . ($on_page * $per_page) . '">' . $user->lang['NEXT'] . '</a>';
+			$page_string .= '&nbsp;&nbsp;<a href="' . clean_viewtopic_url($base_url . "{$url_delim}start=" . ($on_page * $per_page)) . '">' . $user->lang['NEXT'] . '</a>';
 		}
 	}
 
@@ -2073,8 +2073,8 @@ function generate_pagination($base_url, $num_items, $per_page, $start_item, $add
 		'A_' . $tpl_prefix . 'BASE_URL'	=> addslashes($base_url),
 		$tpl_prefix . 'PER_PAGE'		=> $per_page,
 
-		$tpl_prefix . 'PREVIOUS_PAGE'	=> ($on_page == 1) ? '' : $base_url . "{$url_delim}start=" . (($on_page - 2) * $per_page),
-		$tpl_prefix . 'NEXT_PAGE'		=> ($on_page == $total_pages) ? '' : $base_url . "{$url_delim}start=" . ($on_page * $per_page),
+		$tpl_prefix . 'PREVIOUS_PAGE'	=> ($on_page == 1) ? '' : clean_viewtopic_url($base_url . "{$url_delim}start=" . (($on_page - 2) * $per_page)),
+		$tpl_prefix . 'NEXT_PAGE'		=> ($on_page == $total_pages) ? '' : clean_viewtopic_url($base_url . "{$url_delim}start=" . ($on_page * $per_page)),
 		$tpl_prefix . 'TOTAL_PAGES'		=> $total_pages,
 	));
 
@@ -2120,7 +2120,7 @@ function on_page($num_items, $per_page, $start)
 * </code>
 *
 */
-function append_sid($url, $params = false, $is_amp = true, $session_id = false)
+function append_sid_original($url, $params = false, $is_amp = true, $session_id = false)
 {
 	global $_SID, $_EXTRA_URL, $phpbb_hook, $config, $user;
 
@@ -2222,6 +2222,24 @@ function append_sid($url, $params = false, $is_amp = true, $session_id = false)
 	return $url . (($append_url) ? $url_delim . $append_url . $amp_delim : $url_delim) . $params . ((!$session_id) ? '' : $amp_delim . 'sid=' . $session_id) . $anchor;
 }
 
+function clean_viewtopic_url($url)
+{
+	global $phpbb_root_path, $phpEx;
+
+	if (strpos($url, "/viewtopic.$phpEx?") !== false)
+	{
+		return preg_replace('#(\bf=\d+&(amp;)?|&(amp;)?f=\d+$)#', '', $url);
+	}
+
+	return $url;
+}
+
+function append_sid($url, $params = false, $is_amp = true, $session_id = false)
+{
+	$url = append_sid_original($url, $params, $is_amp, $session_id);
+	return clean_viewtopic_url($url);
+}
+
 /**
 * Generate board url (example: http://www.example.com/phpBB)
 *
diff --git a/includes/functions_display.php b/includes/functions_display.php
index 78306c9..5b811bb 100644
--- a/includes/functions_display.php
+++ b/includes/functions_display.php
@@ -710,7 +710,7 @@ function topic_generate_pagination($replies, $url)
 		$times = 1;
 		for ($j = 0; $j < $replies + 1; $j += $per_page)
 		{
-			$pagination .= '<a href="' . $url . ($j == 0 ? '' : '&amp;start=' . $j) . '">' . $times . '</a>';
+			$pagination .= '<a href="' . clean_viewtopic_url($url . ($j == 0 ? '' : '&amp;start=' . $j)) . '">' . $times . '</a>';
 			if ($times == 1 && $total_pages > 5)
 			{
 				$pagination .= '<span class="page-dots"> … </span>';
diff --git a/viewforum.php b/viewforum.php
index afadcbd..6ddd1dd 100644
--- a/viewforum.php
+++ b/viewforum.php
@@ -676,7 +676,7 @@ if (sizeof($topic_list))
 			'LAST_POST_AUTHOR_COLOUR'	=> get_username_string('colour', $row['topic_last_poster_id'], $row['topic_last_poster_name'], $row['topic_last_poster_colour']),
 			'LAST_POST_AUTHOR_FULL'		=> get_username_string('full', $row['topic_last_poster_id'], $row['topic_last_poster_name'], $row['topic_last_poster_colour']),
 
-			'PAGINATION'		=> topic_generate_pagination($replies, $view_topic_url),
+			'PAGINATION'		=> topic_generate_pagination($replies, append_sid_original("{$phpbb_root_path}viewtopic.$phpEx", $view_topic_url_params)),
 			'REPLIES'			=> $replies,
 			'VIEWS'				=> $row['topic_views'],
 			'TOPIC_TITLE'		=> censor_text($row['topic_title']),
diff --git a/viewtopic.php b/viewtopic.php
index 05e815d..7babcb4 100644
--- a/viewtopic.php
+++ b/viewtopic.php
@@ -559,7 +559,7 @@ $topic_mod .= ($auth->acl_get('m_delete', $forum_id)) ? '<option value="delete_t
 $topic_mod .= ($auth->acl_get('m_', $forum_id)) ? '<option value="topic_logs">' . $user->lang['VIEW_TOPIC_LOGS'] . '</option>' : '';
 
 // If we've got a hightlight set pass it on to pagination.
-$pagination = generate_pagination(append_sid("{$phpbb_root_path}viewtopic.$phpEx", "f=$forum_id&amp;t=$topic_id" . ((strlen($u_sort_param)) ? "&amp;$u_sort_param" : '') . (($highlight_match) ? "&amp;hilit=$highlight" : '')), $total_posts, $config['posts_per_page'], $start);
+$pagination = generate_pagination(append_sid_original("{$phpbb_root_path}viewtopic.$phpEx", "f=$forum_id&amp;t=$topic_id" . ((strlen($u_sort_param)) ? "&amp;$u_sort_param" : '') . (($highlight_match) ? "&amp;hilit=$highlight" : '')), $total_posts, $config['posts_per_page'], $start);
 
 // Navigation links
 generate_forum_nav($topic_data);
@@ -655,8 +655,8 @@ $template->assign_vars(array(
 	'S_ENABLE_FEEDS_TOPIC'	=> ($config['feed_topic'] && !phpbb_optionget(FORUM_OPTION_FEED_EXCLUDE, $topic_data['forum_options'])) ? true : false,
 	'S_RATE_ENABLED'		=> $config['rate_enabled'] && (!$config['rate_no_negative'] || !$config['rate_no_positive']),
 
-	'U_CANONICAL'			=> generate_board_url() . "/viewtopic.$phpEx?f=$forum_id&amp;t=$topic_id" . (($start) ? "&amp;start=$start" : ''),
-	'U_TOPIC'				=> "{$server_path}viewtopic.$phpEx?f=$forum_id&amp;t=$topic_id",
+	'U_CANONICAL'			=> clean_viewtopic_url(generate_board_url() . "/viewtopic.$phpEx?f=$forum_id&amp;t=$topic_id" . (($start) ? "&amp;start=$start" : '')),
+	'U_TOPIC'				=> clean_viewtopic_url("{$server_path}viewtopic.$phpEx?f=$forum_id&amp;t=$topic_id"),
 	'U_FORUM'				=> $server_path,
 	'U_VIEW_TOPIC' 			=> $viewtopic_url,
 	'U_VIEW_FORUM' 			=> append_sid("{$phpbb_root_path}viewforum.$phpEx", 'f=' . $forum_id),
